import objectdraw.*;
import java.awt.*;
import java.util.ArrayList;
import javax.swing.*;

/**
 * Describe your program!
 * 
 * Based on starter code provided by Jim Teresco
 * 
 * List your name(s) here.
 */
public class DotsList extends WindowController {

    // large, medium, small sizes for the dots
    private static final int LARGE_DOTSIZE = 150;
    private static final int MEDIUM_DOTSIZE = 100;
    private static final int SMALL_DOTSIZE = 50;

    // menus for size, color, and command
    private JComboBox dotSizeChoice;
    private JComboBox colorChoice;
    private JComboBox commandChoice;

    // *** add any other needed instance variables

    /**
     * Set up the GUI components for the program, initialize ArrayList of shapes.
     */
    public void begin() {
        // create panel to hold choice buttons
        JPanel menuPanel = new JPanel();

        // menu for selecting or adding
        commandChoice = new JComboBox();
        commandChoice.addItem("Add new dot");
        commandChoice.addItem("Recolor dot");
        commandChoice.addItem("Move dot");
        commandChoice.addItem("Delete dot");
        menuPanel.add(commandChoice);

        // Set up menu for dot sizes
        dotSizeChoice = new JComboBox();
        dotSizeChoice.addItem("Small");
        dotSizeChoice.addItem("Medium");
        dotSizeChoice.addItem("Large");
        menuPanel.add(dotSizeChoice);

        // Set up menu for colors
        colorChoice = new JComboBox();
        colorChoice.addItem("Red");
        colorChoice.addItem("Green");
        colorChoice.addItem("Blue");
        menuPanel.add(colorChoice);

        // Add the panel to screen
        getContentPane().add(menuPanel, BorderLayout.SOUTH);
        this.validate();

        // *** construct your ArrayList
    }

    /**
     * When the user clicks in the canvas, check the settings of the command menu to
     * determine what action to take, and perform that action by calling the appropriate
     * helper method.
     * 
     * @param point the Location where the mouse was pressed
     */
    public void onMousePress(Location point) {

        Object buttonLabel = commandChoice.getSelectedItem();

        if (buttonLabel.equals("Add new dot")) {
            addNewDotAt(point);
        } else if (buttonLabel.equals("Recolor dot")) {
            recolorDotAt(point);
        } else if (buttonLabel.equals("Move dot")) {
            selectDotAt(point);
        } else {
            deleteDotAt(point);
        }

        // *** add any additional functionality needed in 
        // *** onMousePress

    }

    /**
     * This method implements the "Add new dot" command.
     * Add a new dot centered at the point.  Size and color of the dot
     * is determined by the settings of the color and dotsize menus.
     * 
     * @param point the Location where the new dot should be centered
     */
    private void addNewDotAt(Location point) {

        // *** the code commented out below will set the variable
        // *** size appropriately based on the currently
        // *** selected value in the dotSizeChoice menu.
        // *** Also make use of getSelectedColor(), which 
        // *** is provided for you.
        /*
        Object sizeString = dotSizeChoice.getSelectedItem();
        double size;

        // select size of new object to be shape chosen
        if (sizeString.equals("Large")) {
        size = LARGE_DOTSIZE;
        }
        else if (sizeString.equals("Medium")) {
        size = MEDIUM_DOTSIZE;
        }
        else {
        size = SMALL_DOTSIZE;
        }
         */

    }

    /**
     * Returns the Color corresponding to the string selected in the
     * color menu.
     * 
     * @return the Color corresponding to the string selected in the color menu.
     */
    private Color getSelectedColor() {
        // get color showing in the color menu
        Object colorString = colorChoice.getSelectedItem();
        Color theColor;

        if (colorString.equals("Red")) {
            theColor = Color.red;
        } else if (colorString.equals("Green")) {
            theColor = Color.green;
        } else {
            theColor = Color.blue;
        }

        return theColor;
    }

    /**
     * Change the color of the dot at the given point.
     * 
     * @param point the Location at which the a dot should be recolored
     */
    private void recolorDotAt(Location point) {

        // *** write me!  Make use of getSelectedColor(), which 
        // *** is provided for you.
    }

    /**
     * Return the index of the "last" dot containing the point.
     * return -1 if no dot contains the point.
     * 
     * @param point the Location at which to find a dot in the shapes list.
     * @return the index of the last element of list containing the point, -1 if not found.
     */
    private int getIndexOf(Location point) {

        // *** this method is not required, but you may find it
        // *** useful to implement it and use it in other methods
        // *** where you need to look up the dot at a given
        // *** Location on the canvas.

        return -1;
    }

    /**
     *  Remove top-most dot at the point, if any.
     *  
     *  @param point the Location at which to attempt to remove a dot.
     */
    private void deleteDotAt(Location point) {
        // *** write me!
    }

    /**
     * Select the top-most dot at the point, and 
     * send it to front of the screen.  If no dot is at the point,
     * then the selection is null.  Also set up for dragging.
     * 
     * @param point the Location at which to select a dot, if any exists.
     */
    private void selectDotAt(Location point) {
        // *** Set up for dragging if there is an object at the
        // *** location.
    }

    /**
     * If a dot was selected then drag it and remember where we left off.
     * 
     * @param point the new Location during the drag operation.
     */
    public void onMouseDrag(Location point) {
        // *** standard dragging procedure...
    }
}
